﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Xml;
using GridAndRepeater.NwindDataSetTableAdapters;
using Telerik.WinControls;
using Telerik.WinControls.UI;

namespace GridAndRepeater
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            // TODO: This line of code loads data into the 'nwindDataSet.Orders' table. You can move, or remove it, as needed.
            this.ordersTableAdapter.Fill(this.nwindDataSet.Orders);
            // TODO: This line of code loads data into the 'nwindDataSet.Customers' table. You can move, or remove it, as needed.
            this.customersTableAdapter.Fill(this.nwindDataSet.Customers);

            //Create column bound to the ID for nested grids
            GridViewDataColumn column = new GridViewDataColumn();
            column.HeaderText = "Orders by customer";
            column.UniqueName = "CustomColumn";
            column.FieldName = "CusomerID";
            column.Width = 300;
        }
         
        public object GetBindingSource(object currentRow, object keyValue)
        {
            NwindDataSet.CustomersRow customer = (NwindDataSet.CustomersRow)((DataRowView)currentRow).Row;
            return new BindingList<NwindDataSet.OrdersRow>(customer.GetOrdersRows());
        }

        private void dataRepeater1_ItemCloned(object sender, Microsoft.VisualBasic.PowerPacks.DataRepeaterItemEventArgs e)
        {
            RadLabel titleLabel = (RadLabel)FindControlInRepeaterItem("ordersTitle", e.DataRepeaterItem);

            SetTitleLabelProperties(titleLabel, Orientation.Vertical);

            RadLabel fieldCaption = (RadLabel)FindControlInRepeaterItem("radLabel1", e.DataRepeaterItem);
            SetTitleLabelProperties(fieldCaption, Orientation.Horizontal);

            fieldCaption = (RadLabel)FindControlInRepeaterItem("radLabel3", e.DataRepeaterItem);
            SetTitleLabelProperties(fieldCaption, Orientation.Horizontal);

            fieldCaption = (RadLabel)FindControlInRepeaterItem("radLabel5", e.DataRepeaterItem);
            SetTitleLabelProperties(fieldCaption, Orientation.Horizontal);

            RadGridView detailGrid = (RadGridView)FindControlInRepeaterItem("ordersInRepeaterGrid", e.DataRepeaterItem);
            CloneGridSettings(this.ordersInRepeaterGrid, detailGrid);

            detailGrid.MasterGridViewTemplate.AutoGenerateColumns = false;
        }

        private void CloneGridSettings(RadGridView sourceGrid, RadGridView targetGrid)
        {
            //copies columns, sorting, grouping, filtering settings, etc
            using(StringWriter stringWriter = new StringWriter())
            {
                using (XmlWriter writer = new XmlTextWriter(stringWriter))
                {
                    sourceGrid.SaveLayout(writer);
                }
                using (StringReader stringReader = new StringReader(stringWriter.ToString()))
                {
                    using (XmlTextReader reader = new XmlTextReader(stringReader))
                    {
                        targetGrid.LoadLayout(reader);
                    }
                }
            }
        }


        private void SetTitleLabelProperties(RadLabel titleLabel, Orientation textOrientation)
        {
            ((Telerik.WinControls.Primitives.FillPrimitive)(titleLabel.GetChildAt(0).GetChildAt(0))).BackColor = System.Drawing.Color.FromArgb(((int)(((byte)(225)))), ((int)(((byte)(254)))), ((int)(((byte)(80)))));
            ((Telerik.WinControls.Primitives.FillPrimitive)(titleLabel.GetChildAt(0).GetChildAt(0))).BackColor2 = System.Drawing.Color.FromArgb(((int)(((byte)(232)))), ((int)(((byte)(253)))), ((int)(((byte)(155)))));
            ((Telerik.WinControls.Primitives.FillPrimitive)(titleLabel.GetChildAt(0).GetChildAt(0))).BackColor3 = System.Drawing.Color.FromArgb(((int)(((byte)(218)))), ((int)(((byte)(251)))), ((int)(((byte)(94)))));
            ((Telerik.WinControls.Primitives.FillPrimitive)(titleLabel.GetChildAt(0).GetChildAt(0))).BackColor4 = System.Drawing.Color.FromArgb(((int)(((byte)(160)))), ((int)(((byte)(202)))), ((int)(((byte)(17)))));
            if (textOrientation == Orientation.Vertical)
            {
                ((Telerik.WinControls.Primitives.FillPrimitive) (titleLabel.GetChildAt(0).GetChildAt(0))).GradientAngle
                    = 0F;
            }

            ((Telerik.WinControls.Primitives.TextPrimitive)(titleLabel.GetChildAt(0).GetChildAt(2).GetChildAt(1))).TextOrientation = textOrientation;
            ((Telerik.WinControls.Primitives.TextPrimitive)(titleLabel.GetChildAt(0).GetChildAt(2).GetChildAt(1))).FlipText = textOrientation == Orientation.Vertical;
            ((Telerik.WinControls.Primitives.TextPrimitive)(titleLabel.GetChildAt(0).GetChildAt(2).GetChildAt(1))).Alignment = System.Drawing.ContentAlignment.MiddleCenter;
        }

        private Control FindControlInRepeaterItem(string controlName, Control parent)
        {
            foreach(Control child in parent.Controls)
            {
                if (child.Name == controlName)
                {
                    return child;
                }
            }

            return null;
        }

        private void dataRepeater1_DrawItem(object sender, Microsoft.VisualBasic.PowerPacks.DataRepeaterItemEventArgs e)
        {
            NwindDataSet.CustomersRow cutsomer = ((NwindDataSet.CustomersRow)((DataRowView)customersBindingSource[e.DataRepeaterItem.ItemIndex]).Row);

            RadGridView detailGrid = (RadGridView)FindControlInRepeaterItem("ordersInRepeaterGrid", e.DataRepeaterItem);
            detailGrid.DataSource =
                    new BindingList<NwindDataSet.OrdersRow>(cutsomer.GetOrdersRows());
        }

    }
}
